using System;
using System.IO;
using Moq;
using NUnit.Framework;

namespace SampleApp.Tests
{
    [TestFixture]
    public class LetterGeneratorTest
    {
        [Test]
        public void CanWriteLetter()
        {

            var appSettingsMock = new Mock<IAppSettings>();
            appSettingsMock.Setup(appS => appS.LetterPath)
                .Returns(@"C:\lettersgohere\");
            

            //create letter generator                
            var fileWriterMock = new Mock<IFileWriter>();

            var letterGenerator = new LetterGenerator(appSettingsMock.Object, fileWriterMock.Object);
            letterGenerator.FirstName = "Bill";
            letterGenerator.LastName = "Johnson";
            letterGenerator.LetterTemplate = "Hello {FirstName} {LastName}";
            letterGenerator.WriteLetter();

            //assert!
            fileWriterMock
                .Verify(fwm => fwm.WriteToFile(It.IsAny<string>(),
                                               "Hello Bill Johnson"), Times.AtMostOnce());
        }
    }
}