using System;

namespace SampleApp
{
    public class LetterGenerator
    {
        private readonly IAppSettings appSettings;
        private readonly IFileWriter fileWriter;
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string LetterTemplate { get; set; }

        public LetterGenerator(IAppSettings appSettings, IFileWriter fileWriter)
        {
            this.appSettings = appSettings;
            this.fileWriter = fileWriter;
        }

        public void WriteLetter()
        {            
            string fileName = String.Format(@"{0}{1}{2}.txt", appSettings.LetterPath, FirstName, LastName);

            string letterContents = LetterTemplate
                .Replace("{FirstName}", FirstName)
                .Replace("{LastName}", LastName);
            
            fileWriter.WriteToFile(fileName, letterContents);
        }
    }
}